package gov.nih.nlm.nls.lvg.Lib;
import java.util.*;
/*****************************************************************************
* This class provides a class for all Lvg Flow specific options.  This 
* class is used in the LvgCmdApi.
*
* <p><b>History:</b>
*
* @author NLM NLS Development Team
*
* @version    V-2010
****************************************************************************/
public class LvgFlowSpecificOption 
{
    // public constructor
    public LvgFlowSpecificOption()
    {
    }
    /**
    * Set the maximum Permutation number for uninflecting words
    *
    * @param   value  maximum permutation number for uninflecting words
    */
    public void SetMaxPermuteTermNum(int value)
    {
        maxPermuteTermNum_ = value;
    }
    /**
    * Set the maximum Metaphone code length
    *
    * @param   value  the maximum Metaphone code length
    */
    public void SetMaxMetaphoneCodeLength(int value)
    {
        maxMetaphoneCodeLength_ = value;
    }
    /**
    * Set the derivation output filter
    *
    * @param   value  value of the type of derivation output filter
    */
    public void SetDerivationFilter(int value)
    {
        derivationFilter_ = value;
    }
    /**
    * Set the inflection output filter
    *
    * @param   value  value of the type of inflection output filter
    */
    public void SetInflectionFilter(int value)
    {
        inflectionFilter_ = value;
    }
    /**
    * Get the maximum permute term number for uninflecting words
    *
    * @return   maximum permute term number for uninflecting words
    */
    public int GetMaxPermuteTermNum()
    {
        return maxPermuteTermNum_;
    }
    /**
    * Get the maximum Metaphone code length
    *
    * @return   the maximum Metaphone code length
    */
    public int GetMaxMetaphoneCodeLength()
    {
        return maxMetaphoneCodeLength_;
    }
    /**
    * Get the derivation output filter
    *
    * @return   value of the type of derivation output filter
    */
    public int GetDerivationFilter()
    {
        return derivationFilter_;
    }
    /**
    * Get the inflection output filter
    *
    * @return   value of the type of inflection output filter
    */
    public int GetInflectionFilter()
    {
        return inflectionFilter_;
    }
    // data members
    // from configuration file
    private int maxPermuteTermNum_ = -1;      // Used in uninflected words -f:B
    private int maxMetaphoneCodeLength_ = -1; // Used in Metaphone -f:m
    // from command line option
    private int derivationFilter_ = OutputFilter.LVG_ONLY;
    private int inflectionFilter_ = OutputFilter.LVG_OR_ALL;
}
