import java.io.*;
import gov.nih.nlm.nls.lvg.Util.*;
/*****************************************************************************
* This class is to print out help menu
*
* <p><b>History:</b>
* <ul>
* </ul>
*
* @author NLM NLS Development Team
*
* @version    V-2010
****************************************************************************/
public class NormHelp
{
    // protected method
    protected static void NormHelp(BufferedWriter bw, boolean fileOutput)
    {
        bw_ = bw;
        fileOutput_ = fileOutput;
        // print out the usage
        MenuPrint("");
        MenuPrint("Synopsis:");
        MenuPrint("  Norm [options]");
        MenuPrint("");
        MenuPrint("Description:");
        MenuPrint("  Normalize text.  That is the lvg flow options -f:q0:g:rs:o:t:l:B:Ct:q7:q8:w.");
        MenuPrint("");
        MenuPrint("Options:");
        MenuPrint("  -ci     Print configuration information.");
        MenuPrint("  -d      Print details of Norm operations.");
        MenuPrint("  -h      Print program help information (this is it).");
        MenuPrint("  -hs     Print option's hierarchy structure."); 
        MenuPrint("  -i:STR  Specify input file name.  The default is screen input.");
        MenuPrint("  -n      Return a \"-No Output-\" message when an input produces no output.");
        MenuPrint("  -o:STR  Specify output file name.  The default is screen output.");
        MenuPrint("  -p      Show the prompt. The default is no prompt.");
        MenuPrint("  -s:STR  Specify a field separator.  The default is \"|\".");
        MenuPrint("  -t:INT  Specify the field to use as the term field.  The default is 1.");
        MenuPrint("  -ti     Display the filtered input term in the output.");
        MenuPrint("  -v      Return the current version identification of Norm.");
        MenuPrint("  -x:STR  Loading an alternative configuration file.");
    }
    // private methods
    private static void MenuPrint(String text)
    {
        try
        {
            Out.Println(bw_, text, fileOutput_, false);
        }
        catch (Exception e)
        {
        }
    }
    private static BufferedWriter bw_ = null;
    private static boolean fileOutput_ = false;
}
