import java.io.*;
import gov.nih.nlm.nls.lvg.Util.*;
/*****************************************************************************
* This class is to print out help menu for WordInd
*
* <p><b>History:</b>
*
* @author NLM NLS Development Team
*
* @version    V-2010
****************************************************************************/
public class WordIndHelp
{
    // protected method
    protected static void WordIndHelp(BufferedWriter bw, boolean fileOutput)
    {
        bw_ = bw;
        fileOutput_ = fileOutput;
        // print out the usage
        MenuPrint("");
        MenuPrint("Synopsis:");
        MenuPrint("  WordInd [options]");
        MenuPrint("");
        MenuPrint("Description:");
        MenuPrint("  Tokenize a term into words.  The \"words\" are output one per line. That is the lvg flow options -f:l:c.");
        MenuPrint("");
        MenuPrint("Options:");
        MenuPrint("  -c      Reserve case (default is to lowercase words).");
        MenuPrint("  -F:INT  Specify field to be copied to outputs.");
        MenuPrint("  -h      Print program help information (this is it).");
        MenuPrint("  -hs     Print option's hierarchy structure."); 
        MenuPrint("  -i:STR  Specify input file name.  The default is screen input.");
        MenuPrint("  -n      Return a \"-No Output-\" message when an input produces no output.");
        MenuPrint("  -o:STR  Specify output file name.  The default is screen output.");
        MenuPrint("  -p      Show the prompt. The default is no prompt.");
        MenuPrint("  -s:STR  Specify a field separator.  The default is \"|\".");
        MenuPrint("  -t:INT  Specify the field to use as the term field.  The default is 1.");
        MenuPrint("  -v      Return the current version identification of WordInd.");
    }
    // private methods
    private static void MenuPrint(String text)
    {
        try
        {
            Out.Println(bw_, text, fileOutput_, false);
        }
        catch (IOException e)
        {
        }
    }
    private static BufferedWriter bw_ = null;
    private static boolean fileOutput_ = false;
}
